"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.patchConsole = void 0;

var _util = _interopRequireDefault(require("util"));

/*
 * This module is used to patch console through our reporter so we can track
 * these logs
 */
const patchConsole = reporter => {
  console.log = (...args) => {
    const format = args[0],
          rest = args.slice(1);
    reporter.log(_util.default.format(format === undefined ? `` : format, ...rest));
  };

  console.warn = (...args) => {
    const format = args[0],
          rest = args.slice(1);
    reporter.warn(_util.default.format(format === undefined ? `` : format, ...rest));
  };

  console.info = (...args) => {
    const format = args[0],
          rest = args.slice(1);
    reporter.info(_util.default.format(format === undefined ? `` : format, ...rest));
  };

  console.error = (format, ...args) => {
    reporter.error(_util.default.format(format, ...args));
  };
};

exports.patchConsole = patchConsole;