"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.startLogger = void 0;

var _semver = _interopRequireDefault(require("semver"));

var _gatsbyCoreUtils = require("gatsby-core-utils");

/*
 * This module is a side-effect filled module to load in the proper logger.
 */
const startLogger = () => {
  let inkExists = false;

  try {
    inkExists = !!require.resolve(`ink`); // eslint-disable-next-line no-empty
  } catch (err) {}

  if (!process.env.GATSBY_LOGGER) {
    if (inkExists && _semver.default.satisfies(process.version, `>=8`) && !(0, _gatsbyCoreUtils.isCI)() && typeof jest === `undefined`) {
      process.env.GATSBY_LOGGER = `ink`;
    } else {
      process.env.GATSBY_LOGGER = `yurnalist`;
    }
  } // if child process - use ipc logger


  if (process.send) {
    // process.env.FORCE_COLOR = `0`
    require(`./loggers/ipc`);
  }

  if (process.env.GATSBY_LOGGER.includes(`json`)) {
    require(`./loggers/json`);
  } else if (process.env.GATSBY_LOGGER.includes(`yurnalist`)) {
    require(`./loggers/yurnalist`);
  } else {
    require(`./loggers/ink`);
  }
};

exports.startLogger = startLogger;